#!/usr/bin/python
# -*- coding: utf-8 -*-

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

# Copyright (C) 2005 Yaacov Zamir

import os
import sys
import gtk
import gtk.glade
import limon

# create widget tree ...
xml = gtk.glade.XML('/usr/share/limon/limon.glade')


def gtk_main_quit(*args):
    gtk.main_quit()


def on_quit_activate(obj):
   gtk.main_quit()


def on_window_delete_event(widget, obj):
    gtk.main_quit()


def on_addwords_activate(obj):
    """ Open browser to add words to dictionary """
    try:
        limon.add()
    except limon.AddError:
        buffer = xml.get_widget('textview').get_buffer()
        buffer.set_text("לא הצלחתי לפתוח דפדפן. ניתן להוסיף ערכים בדף: %s" %
                        limon.addURL)


def on_button_clicked(obj):
    """ Get translation from limon server """
    entry = xml.get_widget('entry').get_text()
    buffer = xml.get_widget('textview').get_buffer()
    
    try:
        translation = limon.translate(entry)
    except limon.TranslateError, err:
        # TODO: make better error message, maybe add link to the site?
        buffer.set_text('תרגום נכשל:' % err)
    else:
        if not translation:
            # TODO: don't tell how to use the menu, add a link to the
            # edit form instead.
            buffer.set_text('לא נמצאו ערכים במילון, אפשר להוסיף את הערך על ידי שימוש בתפריט קובץ ובאפשרות הוסף מילה למאגר')
        else:
            lines = []
            for i, d in enumerate(translation):
                lines.append('%d. %s: %s' % (i + 1, d['he'], d['en']))
                if d['meaning']:
                    lines.append(d['meaning'])
                lines.append('')
            buffer.set_text('\n'.join(lines))


def on_entry_activate(obj):
   on_button_clicked(obj)   


def on_about_activate(obj):
   about = xml.get_widget('aboutdialog')
   about.show()


# set word if given by user
if len(sys.argv) > 1:
    word = sys.argv[1]
    entry = xml.get_widget('entry')
    entry.set_text (word)
    on_button_clicked (0)

# connect handlers
xml.signal_autoconnect(locals())

#hide about dialog
about = xml.get_widget('aboutdialog')
about.hide()

gtk.main()

# ChangeLog:
#
# 17 11 2005
# Nir Soffer <nirs@freeshell.org> : use webbrowser module.
#
